-- ========================================================================== --
-- 										 EskaQuestTracker                                       --
-- @Author   : Skamer <https://mods.curse.com/members/DevSkamer>              --
-- @Website  : https://wow.curseforge.com/projects/eska-quest-tracker         --
-- ========================================================================== --
Scorpio                   "EskaQuestTracker.Classes.Block"               "1.0.0"
-- ========================================================================== --
namespace "EQT"
import "System"
-- ========================================================================== --
class "Block" extend "IFrame"
  event "OnActiveChanged"
  -- ======================================================================== --
  -- Methods
  -- ======================================================================== --

  -- ======================================================================== --
  -- Handlers
  -- ======================================================================== --
  local function SetText(self, new, old, prop)
    self.frame.header.text:SetText(new:upper())
  end
  -- ======================================================================== --
  -- Properties
  -- ======================================================================== --
  property "id" { TYPE = String }
  property "text" { TYPE = String, DEFAULT = "Default Header Text", HANDLER = SetText}
  property "isActive" { TYPE = Boolean, DEFAULT = true, EVENT = "OnActiveChanged" }
  property "priority" { TYPE = Number, DEFAULT = 100 }
  -- ======================================================================== --
  -- Constructors
  -- ======================================================================== --
  __Arguments__ { }
  function Block(self)
    local frame = CreateFrame("Frame")
    frame:SetBackdrop(_Backdrops.CommonWithBiggerBorder)
    frame:SetBackdropColor(0, 0, 0, 0)
    frame:SetBackdropBorderColor(0, 0, 0, 0)

    local headerFrame = CreateFrame("Frame", nil, frame)
    headerFrame:SetPoint("TOPLEFT")
    headerFrame:SetPoint("TOPRIGHT") -- 20 !0
    headerFrame:SetFrameStrata("HIGH") -- BACKGROUND
    headerFrame:SetHeight(24)
    headerFrame:SetBackdrop({	edgeFile = [[Interface\AddOns\EskaQuestTracker\Media\Textures\Frame-Border]], edgeSize = 4 })
    headerFrame:SetBackdropBorderColor(0, 0, 0)
    headerFrame:SetBackdropColor(1, 0,  0)
    frame.header = headerFrame

    local bg = headerFrame:CreateTexture()
    bg:SetAllPoints()
    --bg:SetColorTexture(127/255, 51/255, 0, 0.5)
    bg:SetColorTexture(0, 0, 0, 0.5)
    bg:SetDrawLayer("BACKGROUND", 1)
    headerFrame.bg = bg

    local stripe = headerFrame:CreateTexture()
    stripe:SetAllPoints()
    stripe:SetTexture([[Interface\AddOns\EskaQuestTracker\Media\Textures\Stripe]])
    stripe:SetVertexColor(0, 0, 0, 0.5)

    headerFrame.stripe = stripe

    local font = _LibSharedMedia:Fetch("font", "PT Sans Narrow Bold")

    local headerText = headerFrame:CreateFontString(nil, "OVERLAY")
    headerText:SetPoint("CENTER")
    headerText:SetFont(font, 12, "OUTLINE")
    headerText:SetText(self.text:upper())
    --headerText:SetTextColor(0, 199/255, 1) -- 0, 199/255, 1
  --  headerText:SetTextColor(255/255, 106/255, 0)
    headerText:SetTextColor(0, 199/255, 1)
    headerText:SetShadowColor(0, 0, 0, 0.25)
    headerText:SetShadowOffset(1, -1)
    headerFrame.text = headerText

    self.frame = frame
    self.height = 28
    self.baseHeight = self.height

  end

  __Arguments__{ String, Number }
  function Block(self, id, priority)
    This(self)

    self.id = id
    self.priority = priority
  end



endclass "Block"
