-- ========================================================================== --
-- 										 EskaQuestTracker                                       --
-- @Author   : Skamer <https://mods.curse.com/members/DevSkamer>              --
-- @Website  : https://wow.curseforge.com/projects/eska-quest-tracker         --
-- ========================================================================== --
Scorpio        "EskaQuestTracker.Widgets.ObjectiveTrackerFrame"          "1.0.0"
-- ========================================================================== --
namespace "EQT"

class "ObjectiveTrackerFrame" extend "IFrame"
  -- ======================================================================== --
  -- Handlers
  -- ======================================================================== --
  local function SetContentHeight(self, new, old, prop)
    self.content:SetHeight(new)
    local parentHeight = self.scrollFrame:GetHeight()

    self.scrollFrame:ClearAllPoints()
    self.scrollFrame:SetPoint("TOPLEFT")

    if new >= parentHeight then
      self.scrollbar:Show()
      self.scrollFrame:SetPoint("BOTTOMRIGHT", self.scrollbar, "BOTTOMLEFT")
    else
      self.scrollbar:Hide()
      self.scrollFrame:SetPoint("BOTTOMRIGHT")
    end

    self.content:SetWidth(self.scrollFrame:GetWidth())
  end
  -- ======================================================================== --
  -- Properties
  -- ======================================================================== --
  property "contentHeight" { TYPE = Number, DEFAULT = 50, HANDLER = SetContentHeight }

  function ObjectiveTrackerFrame(self)
    local frame = CreateFrame("Frame", "EQT-ObjectiveTrackerFrame")
    frame:SetBackdrop(_Backdrops.CommonWithBiggerBorder)
    frame:SetBackdropColor(125/255, 125/255, 125/255, 0.25)
    frame:SetBackdropBorderColor(0.1, 0.1, 0.1)
    frame:SetSize(270, 225) --225
    frame:SetPoint("CENTER")
    frame:RegisterForDrag("LeftButton")
    frame:SetScript("OnDragStart", frame.StartMoving)
    frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
    frame:EnableMouse(true)
    frame:SetMovable(true)
    self.frame = frame

    local scrollFrame = CreateFrame("ScrollFrame", "EQT-ObjectiveTrackerFrameScrollFrame", frame, "UIPanelScrollFrameTemplate")
    scrollFrame:SetPoint("TOPLEFT", 0, 0)
    scrollFrame:SetPoint("BOTTOMRIGHT", 0, 0)
    --scrollFrame:SetBackdrop(_Backdrops.Common)
    --scrollFrame:SetBackdropColor(0, 1, 0)



    -- Hide the scroll bar and its buttons
    local scrollbarName = scrollFrame:GetName()
    local scrollbar = _G[scrollFrame:GetName().."ScrollBar"];
    local scrollupbutton = _G[scrollbar:GetName().."ScrollUpButton"];
    local scrolldownbutton = _G[scrollbarName.."ScrollBarScrollDownButton"];

    scrollbar:Hide()
    scrollupbutton:Hide()
    scrollupbutton:ClearAllPoints()
    scrolldownbutton:Hide()
    scrolldownbutton:ClearAllPoints()

    -- customize the scroll bar
    scrollbar:SetBackdrop(_Backdrops.CommonWithBiggerBorder)
    scrollbar:SetBackdropColor(0, 0, 0, 0.5)
    scrollbar:SetBackdropBorderColor(0, 0, 0)
    scrollbar:ClearAllPoints()
    scrollbar:SetPoint("TOPRIGHT", frame, "TOPRIGHT")
    scrollbar:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
    -- customize the scroll bar thumb
    local thumb = scrollbar:GetThumbTexture()
    thumb:SetTexture(_Backdrops.Common.bgFile)
    thumb:SetVertexColor(1, 199/255, 0)
    thumb:SetHeight(40)
    thumb:SetWidth(8)

    -- content
    local content = CreateFrame("Frame", "EQT-ObjectiveTrackerFrameScrollFrameContent", scrollFrame)
    content:SetBackdrop(_Backdrops.Common)
    content:SetBackdropBorderColor(0.1, 0.1, 0.1, 0)
    content:SetBackdropColor(0, 0, 0, 0.15)
    scrollFrame:SetScrollChild(content)
    content:SetHeight(self.contentHeight)
    content:SetWidth(scrollFrame:GetWidth())


    self.content = content
    self.scrollFrame = scrollFrame
    self.scrollbar = scrollbar


  end




endclass "ObjectiveTrackerFrame"
